/* This version installed on 9/5/2021 and works. May be superced by later version
    For Srduino Pro mini
*/

#include <Adafruit_NeoPixel.h>
#define LED_PIN1    2
#define LED_COUNT 30
Adafruit_NeoPixel strip1(LED_COUNT, LED_PIN1, NEO_GRB + NEO_KHZ800);

#include <SoftwareSerial.h>
SoftwareSerial mySerial(A1, A2); // RX, TX


byte groupround;
byte state;
byte number;
byte onedigit;
byte rondone;
byte rondten;
byte groupone;
byte groupten;
uint32_t colour;
byte sequence;

void setup() {
  strip1.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
}

void loop() {
  if (mySerial.available()) {
    GetGSStuff(rondten, rondone, groupten, groupone, state );
    strip1.clear();

    if (sequence == 3) {            // three loops (seconds) then display other group/round
      groupround = !groupround;
      sequence = 0;
    }
    ++sequence;



    if (state == 87 ) { //if its working time LEDs are green
      colour = strip1.Color(0, 255, 125); //R(0-255), G(0-255), B(0-2550
    }
    else { //if its prep time LEDs are red
      colour = strip1.Color( 255, 34 , 0); //R(0-255), G(0-255), B(0-2550
    }

    if (groupround == 1) {
      strip1.clear();
      number = rondone;
      onedigit = rondten;
      numbershow();
      strip1.fill(colour, 20, 2); // displays r
      strip1.fill(colour, 28, 2);
      strip1.show();
    }
    else {
      strip1.clear();
      number = groupone;
      onedigit = groupten;
      numbershow();
      strip1.fill(colour, 16, 10); //displays g
      strip1.show();
    }

  }
}


void numbershow() {
  switch (number) {
    case 0:
      strip1.fill(colour, 0, 12);
      break;
    case 1:
      strip1.fill(colour, 0, 2);
      strip1.fill(colour, 10, 2);
      break;
    case 2:
      strip1.fill(colour, 2, 4);
      strip1.fill(colour, 8, 6);
      break;
    case 3:
      strip1.fill(colour, 0, 4);
      strip1.fill(colour, 8, 6);
      break;
    case 4:
      strip1.fill(colour, 0, 2);
      strip1.fill(colour, 6, 2);
      strip1.fill(colour, 10, 4);
      break;
    case 5:
      strip1.fill(colour, 0, 4);
      strip1.fill(colour, 6, 4);
      strip1.fill(colour, 12, 2);
      break;
    case 6:
      strip1.fill(colour, 0, 10);
      strip1.fill(colour, 12, 2);
      break;
    case 7:
      strip1.fill(colour, 0, 2);
      strip1.fill(colour, 8, 4);
      break;
    case 8:
      strip1.fill(colour, 0, 14);
      break;
    case 9:
      strip1.fill(colour, 0, 4);
      strip1.fill(colour, 6, 8);
  }

  if (onedigit == 1) {
    strip1.fill(colour, 14, 4);
  }
}

void        GetGSStuff(byte& rondten, byte& rondone, byte& groupten, byte& groupone, byte& state) { //parses the string from gliderscore
  boolean GotString = false;
  char InChar;
  char InString[20];
  byte j = 0;
  while (!GotString) {
    if (mySerial.available()) {
      InChar = mySerial.read();
      InString[j] = InChar;
      j += 1;
      if (InChar == '\r') {
        GotString = true;
      }
    }
  }
  // the -48 changes the recived char from ascii to a number for later use in driving LED strings.
  //Not really required but makes it easier to view received data on serial monitor for troubleshooting.
  rondten = (byte)InString[1] - 48;
  rondone = (byte)InString[2] - 48;
  // now group
  groupten = (byte)InString[4] - 48;
  groupone = (byte)InString[5] - 48;
  // now time
  //thousands = (byte)InString[7] -48;
  //hundreds = (byte)InString[8] -48;
  //tens = (byte)InString[9] - 48;
  //ones = (byte)InString[10] -48;
  //now state
  state = (byte)InString[11];

}
